program showdial2;

uses gem, geminit, newobs, pform, windlib, tools,
     dos, resources, alert;

(*$I SHWDIAL2.I*)

type
	OPTIONS		=	record
							jump, dash, center, short : boolean;
						end;	
	OPTIONSFile	=	file of OPTIONS;					
	
var
	menuptr		:	AESTreePtr;
	events		:	EVENT; 
	leave			:	boolean;
	rsc_loaded	:	boolean;
	tree_fixed	:	boolean;
	
	rscpool		:	pointer;
	inf			:	OPTIONSFile;
	opts			:	OPTIONS;
	search		:	SEARCHRec;
	i				:	integer;
	my_rsc		:	RSHDRPtr;
	wind			:	WINDOW;
	windtree		:	AESTreePtr;
	actual_idx	:  integer;
	num_trees	:	integer;
	oldglobal	:	global_ARRAY;
	windtitle	:	string;
	numstring	:	string;
	
	foreign			:	boolean;
	exit_found		:	boolean;
	wrong_editable	: boolean;
	
procedure myrsc; 
external;

{$L shwdial2.o }	
	
procedure dummyproc(windptr: WINDOWPtr);	
begin
end;


procedure send_redraw;
var
	pipe	:	ARRAY_8;
begin
	pipe[0] := WM_REDRAW;
   pipe[1] := apID;
   pipe[2] := 0;
   pipe[3] := wind.handle;
   pipe[4] := wind.work.g_x;
   pipe[5] := wind.work.g_y;
   pipe[6] := wind.work.g_w;
   pipe[7] := wind.work.g_h;
   appl_write(apID, 16, @pipe);
end;

function spec_chars: integer;
var
	tree	:	AESTreePtr;
	ret		:	integer;
begin
	tree := getresource(rscpool, ASCIIPOP);	
	with tree^[ROOT] do
	begin
		graf_mkstate(ob_x, ob_y, ret, ret);
		dec(ob_x, ob_width div 2);
		ob_x := max(ob_x, 0);
		dec(ob_y, ob_height div 2);
		ob_y := max(ob_y, 0);
	end;
	ret := pop_up(tree);		
	if ret = - 1 then
		spec_chars := S_INSERT
	else	
	begin
		spec_chars := integer(pchar(tree^[ret].ob_spec.free_string)^);
	end;
end;	


function find_user(tree: AESTreePtr; obj: integer): boolean;
begin
	if lo(tree^[obj].ob_type) = G_USERDEF then 
		foreign := TRUE;
	find_user := TRUE;	
end;

function check_editable(tree: AESTreePtr; obj: integer): boolean;
begin
	if is_flag(tree^[obj], EDITABLE) and 
		((lo(tree^[obj].ob_type) in [G_FTEXT, G_FBOXTEXT]) = FALSE) then
		wrong_editable := TRUE;
	check_editable := TRUE;			
end;
	
function find_exit(tree: AESTreePtr; obj: integer): boolean;
begin
	if is_flag(tree^[obj], F_EXIT) and 
		is_enabled(tree^[obj]) and
	  	(not is_flag(tree^[obj], HIDETREE)) then
	  	exit_found := TRUE;
	if is_flag(tree^[obj], TOUCHEXIT) and
		(not is_flag(tree^[obj], HIDETREE)) and
	  	(not is_state(tree^[obj], DISABLED)) then
	  	exit_found := TRUE;	 	 	
	find_exit := TRUE;
end;


procedure drawdial(windptr: WINDOWPtr);
var
	y, x	:	integer;
begin
	if windtree <> NIL then
	begin
		with windptr^ do
		begin
			windtree^[ROOT].ob_x := work.g_x - doc_x;
			windtree^[ROOT].ob_y := work.g_y - doc_y;
			with clip do
				objc_draw(windtree, ROOT, MAX_DEPTH, g_x, g_y, g_w, g_h);   
		end;
	end
	else
	begin
		y := windptr^.work.g_y + charheight - windptr^.doc_y;
		x := windptr^.work.g_x - windptr^.doc_x;
		if foreign then
		begin
      	v_gtext(vdihandle, x, y,
      	        'Dieser Baum kann nicht gezeichnet werden, da er');
			inc(y, charheight);
			v_gtext(vdihandle, x, y,
      	        'unbekannte G_USERDEF-Objekte enthlt!');      	        
	      (*inc(y, charheight);*)
	  	end;    
	end;      
end; 	


procedure next_tree;
var
	pipe	:	ARRAY_8;
begin
	foreign := FALSE;
	
	if tree_fixed then
	begin
		tree_fixed := FALSE;
		fix_tree(windtree, FALSE);
	end;	
	
	inc(actual_idx);
	if actual_idx = num_trees then
		actual_idx := 0;
	rsrc_gaddr(R_TREE, actual_idx, pointer(windtree));		
	
	maptree(windtree, ROOT, -1, find_user);
	if foreign then
	begin
		with wind do
		begin
			doc_x := 0;
			doc_y := 0;
			doc_height := 2 * charheight;
			doc_width  := 75 * charwidth;
		end;	
		windtree := NIL
	end
	else
		with wind do
		begin
			doc_x := 0;
			doc_y := 0;
			doc_height := windtree^[ROOT].ob_height;
			doc_width  := windtree^[ROOT].ob_width;
		end;
		
	str(actual_idx, numstring);
	windsettitle(wind.handle, 'Baum #' + numstring, windtitle);
	send_redraw;
	pipe[0] := WM_SIZED;
   pipe[1] := apID;
   pipe[2] := 0;
   pipe[3] := wind.handle;
   wind_calc(WC_BORDER, wind.elements, wind.work.g_x, wind.work.g_y,
             wind.work.g_w, wind.work.g_h, pipe[4], pipe[5], pipe[6],
             pipe[7]);
  	
  	appl_write(apID, 16, @pipe);           
end;

procedure prev_tree;
var
	pipe	:	ARRAY_8;
begin
	foreign := FALSE;
	
	if tree_fixed then
	begin
		tree_fixed := FALSE;
		fix_tree(windtree, FALSE);
	end;	
	
	dec(actual_idx);
	if actual_idx < 0 then
		actual_idx := num_trees - 1;
	rsrc_gaddr(R_TREE, actual_idx, pointer(windtree));		
	
	maptree(windtree, ROOT, -1, find_user);
	if foreign then
	begin
		with wind do
		begin
			doc_x := 0;
			doc_y := 0;
			doc_height := 2 * charheight;
			doc_width  := 75 * charwidth;
		end;	
		windtree := NIL
	end
	else
		with wind do
		begin
			doc_x := 0;
			doc_y := 0;
			doc_height := windtree^[ROOT].ob_height;
			doc_width  := windtree^[ROOT].ob_width;
		end;
	str(actual_idx, numstring);
	windsettitle(wind.handle, 'Baum #' + numstring, windtitle);
	send_redraw;
   pipe[0] := WM_SIZED;
   pipe[1] := apID;
   pipe[2] := 0;
   pipe[3] := wind.handle;
   wind_calc(WC_BORDER, wind.elements, wind.work.g_x, wind.work.g_y,
             wind.work.g_w, wind.work.g_h, pipe[4], pipe[5], pipe[6],
             pipe[7]);
  	appl_write(apID, 16, @pipe);           
end;
	
function select_file(titel, mask: string): string;
var
   dir				: dirstr;
   path, filename : string;
   name 				: namestr;
   ext 				: extstr;
   exitButton 		: integer;
begin
   path := fexpand('') + mask;;   
   filename := '';
   
   with GEM_pb do
   	if ((global[0] >= $140) and (global[0] < $200)) or
   	   (global[0] >= $300) then
      	fsel_exinput(path, filename, exitButton, titel)
  	 	else
       	fsel_input(path, filename, exitButton);
       
   if (exitButton = 0) or (filename = '') then
   begin
       select_file := '';
       exit;
   end;

   fsplit(path, dir, name, ext);
   select_file := dir + filename;
end;
	



procedure close_rsc;
begin	
   
	if tree_fixed then
	begin
		tree_fixed := FALSE;
		fix_tree(windtree, FALSE);
	end;	
	if rsc_loaded then
	begin
		if wind.handle <> -1 then
			close_window(wind);
		rsrc_free;
		AES_pb.global^ := oldglobal;
	end;	
	rsc_loaded := FALSE;
end;	

procedure close_proc(windptr: WINDOWPtr);
begin
	if tree_fixed then
	begin
		tree_fixed := FALSE;
		fix_tree(windtree, FALSE);
	end;	
	if rsc_loaded then
	begin
		rsrc_free;
		AES_pb.global^ := oldglobal;
	end;	
	rsc_loaded := FALSE;
end;			
   			
procedure open_rscwind;
var
	coords	:	GRECT;
begin
	with wind do
	begin
		handle := -1;
		elements := NAME + CLOSER + FULLER +  MOVER + SIZER +
		            UPARROW + DNARROW + VSLIDE + HSLIDE + LFARROW + 
		            RTARROW;
		scroll_x := charwidth;
		scroll_y := charheight;		            
		align 	:= TRUE;
		doc_x := 0;
		doc_y := 0;
		if windtree <> NIL then
		begin
			doc_height := windtree^[ROOT].ob_height;
			doc_width  := windtree^[ROOT].ob_width;
		end
		else
		begin
		   	doc_height := 2 * charheight;
			doc_width  := 75 * charwidth;
		end;
		redraw 	:= drawdial;
		untopped := dummyproc;
		topped := dummyproc;
		closed := close_proc;
		moved := dummyproc;
		next := NIL;
		wind_spec := NIL;
		wind_type := WI_NOTYPE;
	end;
	with coords do
			wind_get(0, WF_WORKXYWH, g_x, g_y, g_w, g_h);
	create_window(wind, coords);
	str(actual_idx, numstring);
	windsettitle(wind.handle, 'Baum #' + numstring, windtitle);
	open_window(wind, coords, '', '');
end;	
	 
procedure open_rsc;
type
	RSHDRPtrPtr	=	^RSHDRPtr;
var
	rscname 	:	string;
	dir		:	DIRStr;
	name		:	NAMEStr;
	ext		:	EXTStr;
begin
	rscname := select_file('RSC-File auswhlen', '*.RSC');
	if rscname = '' then
		exit;
	fsplit(rscname, dir, name, ext);
	chdir(dir);	
	
	oldglobal := AES_pb.global^;
	if rsrc_load(rscname) <> 0 then
	begin
		rsc_loaded := TRUE;
		num_trees := ((RSHDRPtrPtr(@(AES_pb.global^[7])))^)^.rsh_ntree;
		actual_idx := 0;
		rsrc_gaddr(R_TREE, actual_idx, pointer(windtree));
				maptree(windtree, ROOT, -1, find_user);
		if foreign then
			windtree := NIL;
		open_rscwind;
	end;
end;		
	
procedure fix_resource(initmode: boolean);
var
	tree		:	AESTreePtr;
	i			:	integer;
begin	
	for i := 0 to pred(my_rsc^.rsh_ntree) do
	begin
		rsrc_gaddr(R_TREE, i, pointer(tree));
		fix_tree(tree, initmode);
	end;
end;			

procedure do_about;
var
	tree, subtree			:	AESTreePtr;
	ret, dx, dy, dw, dh	:	integer;
	sf							:	SUBPFORM;
begin
	tree 	  := getresource(rscpool, ABOUTDIAL);
	subtree := getresource(rscpool, GENHELPDIAL);
	wind_update(BEG_UPDATE);
	wind_update(BEG_MCTRL);
	pform_center(tree, dx, dy, dw, dh);
	pform_dial(FMD_START, dx, dy, dw, dh, dx, dy, dw, dh);
	objc_draw(tree, ROOT, MAX_DEPTH, dx, dy, dw, dh);
	ret := pform_do(tree, 0);
	while ret = HELP_ABOUTDIAL do
	begin
	  	init_subdial(tree, sf); 
	  	do_dialog(subtree, 0);
	  	exit_subdial(sf);			  
	  	deselect(tree^[ret]);
	  	draw_object(tree, ret);
	  	ret := pform_do(tree, 0);
	end;  
	deselect(tree^[ret]);
	pform_dial(FMD_FINISH, dx, dy, dw, dh, dx, dy, dw, dh);  
	wind_update(END_MCTRL);
	wind_update(END_UPDATE);  
end;

procedure do_parameters;
var
	tree, subtree			:	AESTreePtr;
	ret, dx, dy, dw, dh	:	integer;
	sf							:	SUBPFORM;
begin
	tree := getresource(rscpool, PARAMETERDIAL);
	subtree := getresource(rscpool, PARMHELPDIAL);
	with opts do
	begin
		if jump then 
			set_state(tree^[JUMP_ON], SELECTED)
		else
			unset_state(tree^[JUMP_ON], SELECTED);
			
		if dash then 
			set_state(tree^[CHANGE_DASHES], SELECTED)
		else
			unset_state(tree^[CHANGE_DASHES], SELECTED);
			
		if center then 
			set_state(tree^[FAST_CENTER], SELECTED)
		else
			unset_state(tree^[FAST_CENTER], SELECTED);
			
		if short then 
			set_state(tree^[SHORT_TITLES], SELECTED)
		else
			unset_state(tree^[SHORT_TITLES], SELECTED);		
	end;
	
	wind_update(BEG_UPDATE);
	wind_update(BEG_MCTRL);
	pform_center(tree, dx, dy, dw, dh);
	pform_dial(FMD_START, dx, dy, dw, dh, dx, dy, dw, dh);
			
	objc_draw(tree, ROOT, MAX_DEPTH, dx, dy, dw, dh);
	ret := pform_do(tree, 0);
	while ret = HELP_PARAMETERDI do
	begin
	  	init_subdial(tree, sf); 
	  	if do_dialog(subtree, 0) = MORE_PARMHELPDIA then
	  	begin
	  		subtree := getresource(rscpool, PARM2HELPDIAL);
	  		do_dialog(subtree, 0);
	  		subtree := getresource(rscpool, PARMHELPDIAL);
	  	end;	
	  	exit_subdial(sf);			  
	  	deselect(tree^[ret]);
	  	draw_object(tree, ret);
	  	ret := pform_do(tree, 0);
	end;  
	deselect(tree^[ret]);
	
	pform_dial(FMD_FINISH, dx, dy, dw, dh, dx, dy, dw, dh);  
	wind_update(END_MCTRL);
	wind_update(END_UPDATE);  
	
	if ret = OK_PARAMETERDIAL then
		with opts do
		begin
			jump 	 := is_state(tree^[JUMP_ON], SELECTED);
			dash   := is_state(tree^[CHANGE_DASHES], SELECTED);
			center := is_state(tree^[FAST_CENTER], SELECTED); 
			short  := is_state(tree^[SHORT_TITLES], SELECTED);
			set_jumpmode(jump);
			set_dashmode(dash);
			set_shorttitle(short);
			set_fastcenter(center);
		end;
	if rsc_loaded then
		send_redraw;	
end;

procedure save_options;
begin
	assign(inf, 'shwdial2.inf');
	rewrite(inf);
	write(inf, opts);
	close(inf);
end;

procedure do_test;
begin
	exit_found		:= FALSE;
	wrong_editable	:= FALSE;
	maptree(windtree, ROOT, -1, find_exit);	
	
	if not exit_found then
	begin
		do_alert(@GEM2STOP, 'Dieser Objektbaum hat kein' + 
		        ' (TOUCH)EXIT-Objekt! Er kann daher nicht ' +
		        'getestet werden.',
		        ' [Abbruch ', 0, 0);
		exit;	         
		
	end;
	
	maptree(windtree, ROOT, -1, check_editable);
	if wrong_editable then
	begin
		do_alert(@GEM2STOP, 'Dieser Objektbaum hat EDITABLE-'+
					'Objekte, die nicht vom Typ F(BOX)TEXT sind! '+
		        'Er kann daher nicht getestet werden.',
		        ' [Abbruch ', 0, 0);
		exit;
	end;

	do_dialog(windtree, 0);
end;
	
procedure do_fix;
begin
	tree_fixed := not tree_fixed;
	fix_tree(windtree, tree_fixed);
	send_redraw;
end;

	
procedure event_loop(var events: EVENT);
var
	leave, mn_key, mn_click	:	boolean;
	which, title, entry		:	integer;
	tree							:	AESTreePtr;
begin
	leave := FALSE;
	repeat
		which := EvntMulti(events);
		
		if ((which and MU_BUTTON) <> 0) and	rsc_loaded then 
		begin
			if wind.handle = wind_find(events.ev_mmox, events.ev_mmoy) then
			begin
				tree := getresource(rscpool, TREEPOP);
				with tree^[ROOT] do
				begin
					graf_mkstate(ob_x, ob_y, entry, entry);
					dec(ob_x, ob_width div 2);
					ob_x := max(ob_x, 0);
					dec(ob_y, ob_height div 2);
					ob_y := max(ob_y, 0);
				end;
				case pop_up(tree) of
					FIX_IT	:	do_fix;   
    				TEST_IT  :	do_test;
    				GO_FORTH	:	next_tree;	
    				GO_BACK 	:	prev_tree;
				end;
			end;
		end;	
			
		if (which and MU_MESAG)	<> 0 then		                    
			handle_window(events.ev_mmgpbuf);
			
		mn_key := FALSE;	
		if (which and MU_KEYBD) <> 0 then
		begin
			mn_key := search_menu(menuptr, events.ev_mmokstate,
			                     events.ev_mkreturn, title, entry);
		end;
		
		mn_click := FALSE;	
		if ((which and MU_MESAG) <> 0) and 
			(events.ev_mmgpbuf[0] = MN_SELECTED) then
		begin
			mn_click := TRUE;
			title := events.ev_mmgpbuf[3];
			entry := events.ev_mmgpbuf[4];
		end;
					
		if mn_key or mn_click then 
		begin
			case entry of 
				ABOUT:
					do_about;
				
				OPEN:
					open_rsc;
					
				P_CLOSE:
					close_rsc;
					
				QUIT:
				begin
					close_rsc;
					leave := TRUE;
				end;
					
				FIX:
					do_fix;
				
				TEST:
					do_test;
				
				NEXT:
					next_tree;
					
				PREVIOUS:
					prev_tree;
					
				SET_PARAMETERS:
					do_parameters;
				
				SAVE_PARAMETERS:
					save_options;
				
				GENERAL:
				begin
					tree := getresource(rscpool, GENHELPDIAL);
					do_dialog(tree, 0);
				end;
					
				HELPFILE:
				begin
					tree := getresource(rscpool, FILEHELPDIAL);
					do_dialog(tree, 0);
				end;
				
				HELPTREE:
				begin
					tree := getresource(rscpool, TREEHELPDIAL);
					do_dialog(tree, 0);
				end;
				
				HELPPARAMETERS:
				begin
					tree := getresource(rscpool, PARMHELPDIAL);
					wind_update(BEG_MCTRL);
					if do_dialog(tree, 0) = MORE_PARMHELPDIA then
					begin
						tree := getresource(rscpool, PARM2HELPDIAL);
						do_dialog(tree, 0);
					end;
					wind_update(END_MCTRL);
				end;
				
			end;
			menu_tnormal(menuptr, title, 1);
	
		end;
		
		if rsc_loaded then
		begin
			if not is_state(menuptr^[OPEN], DISABLED) then
				menu_ienable(menuptr, OPEN, 0);
			if is_state(menuptr^[P_CLOSE], DISABLED) then	
				menu_ienable(menuptr, P_CLOSE, 1);
			if is_state(menuptr^[OBJECTTREE], DISABLED) then	
			begin
				menu_ienable(menuptr, OBJECTTREE, 1);
				draw_object(menuptr, OBJECTTREE);
			end;	
			if foreign then
			begin
				menu_ienable(menuptr, FIX, 0);	
				menu_ienable(menuptr, TEST, 0);
				tree := getresource(rscpool, TREEPOP);
				set_state(tree^[FIX_IT], DISABLED);
				set_state(tree^[TEST_IT], DISABLED);
			end
			else
			begin
				menu_ienable(menuptr, FIX, 1);
				menu_ienable(menuptr, TEST, 1);
				tree := getresource(rscpool, TREEPOP);
				unset_state(tree^[FIX_IT], DISABLED);
				unset_state(tree^[TEST_IT], DISABLED);
			end;		
		end
		else
		begin
			if is_state(menuptr^[OPEN], DISABLED) then
				menu_ienable(menuptr, OPEN, 1);
			if not is_state(menuptr^[P_CLOSE], DISABLED) then					
				menu_ienable(menuptr, P_CLOSE, 0);
			if not is_state(menuptr^[OBJECTTREE], DISABLED) then	
			begin		
				menu_ienable(menuptr, OBJECTTREE, 0);
				draw_object(menuptr, OBJECTTREE);
			end;	
		end;
	until leave;	
end;	
	
begin
	if not initgem then
		exit;
	
	my_rsc := @myrsc;
	rscpool := initresourcepool(my_rsc);
	
	init_pform(vdihandle, FALSE);
	init_windows(vdihandle);
	init_newobs(vdihandle);
	
	fix_resource(TRUE);

	set_insert(spec_chars);	
	findfirst('shwdial2.inf', 0, search);
	if doserror = 0 then
	begin
		assign(inf, 'shwdial2.inf');
		reset(inf);
		read(inf, opts);
		close(inf);
		with opts do
		begin
			set_jumpmode(jump);
			set_dashmode(dash);
			set_shorttitle(short);
			set_fastcenter(center);
		end;	
	end
	else
	begin
		opts.jump   := TRUE;
		opts.dash   := TRUE;
		opts.center := TRUE;
		opts.short  := FALSE;
	end;
	
	
	menuptr := getresource(rscpool, MENU);
	menu_ienable(menuptr, P_CLOSE, 0);
	menu_ienable(menuptr, OBJECTTREE, 0);

	menu_bar(menuptr, 1);
	graf_mouse(ARROW, NIL); 
	
	rsc_loaded := FALSE;
	tree_fixed := FALSE;
	 		
   with events do                
   begin
   	ev_mflags 		:= MU_KEYBD or MU_BUTTON or MU_MESAG;
   	ev_mbclicks		:=	1;
   	ev_bmask 		:= 1;  
   	ev_mbstate 	 		:= 1;
   	ev_mm1flags 	:= 0;
   	ev_mm1width 	:= 0;
   	ev_mm1height 	:= 0;
   	ev_mm2flags 	:= 0;
   	ev_mm2width 	:= 0;
   	ev_mm2height	:= 0;
   	ev_mm2x 			:= 0;
   	ev_mm2y 			:= 0;
   	ev_mtlocount 	:= 0;
   	ev_mthicount 	:= 0;
   end;
	   			
	event_loop(events);
	
	fix_resource(FALSE);
	
	exit_pform;
	freeresourcepool(rscpool);
	exitgem;
end.		
